#include <Time.h>  

String readString;


void setup()  {
  Serial.begin(9600);
  //Serial.println("Waiting for sync message");
}

void loop(){   
  
  if(Serial.available() ) 
  {
    //int val = Serial.read() - '0';
    //Serial.println(val);
    processSyncMessage(); // Função que processa os valores passados para o serial monitor 
                          // e transforma em horário
  }
  delay(1000);
  digitalClockDisplay();  // função que faz print das horas no formato correcto
  
}
 

 void digitalClockDisplay(){
  // digital clock display of the time
  Serial.print(hour());
  printDigits(minute());
  printDigits(second());
  Serial.print(" ");
  Serial.print(day());
  Serial.print(" ");
  Serial.print(month());
  Serial.print(" ");
  Serial.print(year()); 
  Serial.println(); 
}

void printDigits(int digits){
  // utility function for digital clock display: prints preceding colon and leading 0
  Serial.print(":");
  if(digits < 10)
    Serial.print('0');
  Serial.print(digits);
}


void processSyncMessage() {
  
  
if(Serial.available() ){
   char horas[3] = { Serial.read(), Serial.read() , ':'};
   Serial.read();//flush the delim ( nao sei bem o que isto faz, apenas segui um exemplo)
   char minutos[3] = { Serial.read(), Serial.read() , ':' };
   Serial.read();//flush the delim
   char segundos[3] = { Serial.read(), Serial.read() , '-' };
   Serial.read();//flush the delim
   char dia[3] = { Serial.read(), Serial.read() , '/' };
   Serial.read();//flush the delim
   char mes[3] = { Serial.read(), Serial.read() , '/' };
   Serial.read();//flush the delim
   char ano[5] = { Serial.read(), Serial.read() , Serial.read(), Serial.read(), '\0' };
 
   int horas2=atoi(horas);  // passar de ascii para int para a função setTime
   Serial.println(horas2);
   
   int minutos2=atoi(minutos);
   Serial.println(minutos2);
   
   int segundos2=atoi(segundos);
   Serial.println(segundos2);
   
   int dia2=atoi(dia);
   Serial.println(dia2);
   
   int mes2=atoi(mes);
   Serial.println(mes2);
   
   int ano2=atoi(ano);
   Serial.println(ano2);
   
   setTime(horas2,minutos2,segundos2,dia2,mes2,ano2); // função que actualiza o horario, tÊm é de ser valores int
 }
}
    
    
    
 



/* if(flag==0)
    {
      if(Serial.available()>0 ) 
      {
        for(int i=0; i<2; i++) 
        { 
        hor=Serial.read();
        if( hor >= '0' && hor <= '9')
          {  
          hor2[i]=hor;
          horas=atoi(hor2);
          }  
        }
          
      }flag=1;
       
    //Serial.println(horas);
    }
    Serial.println(horas);
    */
